<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/miniz_oxide-0.5.3/src/deflate/buffer.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>buffer.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../../storage.js"></script><script defer src="../../../source-script.js"></script><script defer src="../../../source-files.js"></script><script defer src="../../../main.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../../miniz_oxide/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../../miniz_oxide/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../../miniz_oxide/index.html"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
</pre><pre class="rust"><code><span class="doccomment">//! Buffer wrappers implementing default so we can allocate the buffers with `Box::default()`</span>
<span class="doccomment">//! to avoid stack copies. Box::new() doesn&#39;t at the moment, and using a vec means we would lose</span>
<span class="doccomment">//! static length info.</span>

<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::deflate::core</span>::{<span class="ident">LZ_DICT_SIZE</span>, <span class="ident">MAX_MATCH_LEN</span>};

<span class="doccomment">/// Size of the buffer of lz77 encoded data.</span>
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">LZ_CODE_BUF_SIZE</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="number">64</span> <span class="op">*</span> <span class="number">1024</span>;
<span class="doccomment">/// Size of the output buffer.</span>
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">OUT_BUF_SIZE</span>: <span class="ident">usize</span> <span class="op">=</span> (<span class="ident">LZ_CODE_BUF_SIZE</span> <span class="op">*</span> <span class="number">13</span>) <span class="op">/</span> <span class="number">10</span>;
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">LZ_DICT_FULL_SIZE</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="ident">LZ_DICT_SIZE</span> <span class="op">+</span> <span class="ident">MAX_MATCH_LEN</span> <span class="op">-</span> <span class="number">1</span> <span class="op">+</span> <span class="number">1</span>;

<span class="doccomment">/// Size of hash values in the hash chains.</span>
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">LZ_HASH_BITS</span>: <span class="ident">i32</span> <span class="op">=</span> <span class="number">15</span>;
<span class="doccomment">/// How many bits to shift when updating the current hash value.</span>
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">LZ_HASH_SHIFT</span>: <span class="ident">i32</span> <span class="op">=</span> (<span class="ident">LZ_HASH_BITS</span> <span class="op">+</span> <span class="number">2</span>) <span class="op">/</span> <span class="number">3</span>;
<span class="doccomment">/// Size of the chained hash tables.</span>
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">LZ_HASH_SIZE</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="ident">LZ_HASH_BITS</span>;

<span class="attribute">#[<span class="ident">inline</span>]</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">update_hash</span>(<span class="ident">current_hash</span>: <span class="ident">u16</span>, <span class="ident">byte</span>: <span class="ident">u8</span>) -&gt; <span class="ident">u16</span> {
    ((<span class="ident">current_hash</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="ident">LZ_HASH_SHIFT</span>) <span class="op">^</span> <span class="ident">u16::from</span>(<span class="ident">byte</span>)) <span class="op">&amp;</span> (<span class="ident">LZ_HASH_SIZE</span> <span class="kw">as</span> <span class="ident">u16</span> <span class="op">-</span> <span class="number">1</span>)
}

<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">HashBuffers</span> {
    <span class="kw">pub</span> <span class="ident">dict</span>: [<span class="ident">u8</span>; <span class="ident">LZ_DICT_FULL_SIZE</span>],
    <span class="kw">pub</span> <span class="ident">next</span>: [<span class="ident">u16</span>; <span class="ident">LZ_DICT_SIZE</span>],
    <span class="kw">pub</span> <span class="ident">hash</span>: [<span class="ident">u16</span>; <span class="ident">LZ_DICT_SIZE</span>],
}

<span class="kw">impl</span> <span class="ident">HashBuffers</span> {
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">reset</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) {
        <span class="kw-2">*</span><span class="self">self</span> <span class="op">=</span> <span class="ident">HashBuffers::default</span>();
    }
}

<span class="kw">impl</span> <span class="ident">Default</span> <span class="kw">for</span> <span class="ident">HashBuffers</span> {
    <span class="kw">fn</span> <span class="ident">default</span>() -&gt; <span class="ident">HashBuffers</span> {
        <span class="ident">HashBuffers</span> {
            <span class="ident">dict</span>: [<span class="number">0</span>; <span class="ident">LZ_DICT_FULL_SIZE</span>],
            <span class="ident">next</span>: [<span class="number">0</span>; <span class="ident">LZ_DICT_SIZE</span>],
            <span class="ident">hash</span>: [<span class="number">0</span>; <span class="ident">LZ_DICT_SIZE</span>],
        }
    }
}

<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">LocalBuf</span> {
    <span class="kw">pub</span> <span class="ident">b</span>: [<span class="ident">u8</span>; <span class="ident">OUT_BUF_SIZE</span>],
}

<span class="kw">impl</span> <span class="ident">Default</span> <span class="kw">for</span> <span class="ident">LocalBuf</span> {
    <span class="kw">fn</span> <span class="ident">default</span>() -&gt; <span class="ident">LocalBuf</span> {
        <span class="ident">LocalBuf</span> {
            <span class="ident">b</span>: [<span class="number">0</span>; <span class="ident">OUT_BUF_SIZE</span>],
        }
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../../" data-current-crate="miniz_oxide" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>